/*******************************************************************************
 * Copyright (c) 2000, 2020 IBM Corp. and others
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at http://eclipse.org/legal/epl-2.0
 * or the Apache License, Version 2.0 which accompanies this distribution
 * and is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following Secondary
 * Licenses when the conditions for such availability set forth in the
 * Eclipse Public License, v. 2.0 are satisfied: GNU General Public License,
 * version 2 with the GNU Classpath Exception [1] and GNU General Public
 * License, version 2 with the OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] http://openjdk.java.net/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0 WITH Classpath-exception-2.0 OR LicenseRef-GPL-2.0 WITH Assembly-exception
 *******************************************************************************/

/*
 * This table is #included in a static table.
 * Only Function Pointers are allowed.
 */

#define _BadILOpEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _aconstEvaluator TR::TreeEvaluator::aconstEvaluator
#define _iconstEvaluator TR::TreeEvaluator::iconstEvaluator
#define _lconstEvaluator TR::TreeEvaluator::lconstEvaluator
#define _fconstEvaluator TR::TreeEvaluator::fconstEvaluator
#define _dconstEvaluator TR::TreeEvaluator::dconstEvaluator
#define _bconstEvaluator TR::TreeEvaluator::bconstEvaluator
#define _sconstEvaluator TR::TreeEvaluator::sconstEvaluator
#define _iloadEvaluator TR::TreeEvaluator::iloadEvaluator
#define _floadEvaluator TR::TreeEvaluator::floadEvaluator
#define _dloadEvaluator TR::TreeEvaluator::dloadEvaluator
#define _aloadEvaluator TR::TreeEvaluator::aloadEvaluator
#define _bloadEvaluator TR::TreeEvaluator::bloadEvaluator
#define _sloadEvaluator TR::TreeEvaluator::sloadEvaluator
#define _lloadEvaluator TR::TreeEvaluator::lloadEvaluator
#define _irdbarEvaluator TR::TreeEvaluator::irdbarEvaluator
#define _frdbarEvaluator TR::TreeEvaluator::frdbarEvaluator
#define _drdbarEvaluator TR::TreeEvaluator::drdbarEvaluator
#define _ardbarEvaluator TR::TreeEvaluator::ardbarEvaluator
#define _brdbarEvaluator TR::TreeEvaluator::brdbarEvaluator
#define _srdbarEvaluator TR::TreeEvaluator::srdbarEvaluator
#define _lrdbarEvaluator TR::TreeEvaluator::lrdbarEvaluator
#define _iloadiEvaluator TR::TreeEvaluator::iloadEvaluator
#define _floadiEvaluator TR::TreeEvaluator::floadEvaluator
#define _dloadiEvaluator TR::TreeEvaluator::dloadEvaluator
#define _aloadiEvaluator TR::TreeEvaluator::aloadEvaluator
#define _bloadiEvaluator TR::TreeEvaluator::bloadEvaluator
#define _sloadiEvaluator TR::TreeEvaluator::sloadEvaluator
#define _lloadiEvaluator TR::TreeEvaluator::lloadEvaluator
#define _irdbariEvaluator TR::TreeEvaluator::irdbariEvaluator
#define _frdbariEvaluator TR::TreeEvaluator::frdbariEvaluator
#define _drdbariEvaluator TR::TreeEvaluator::drdbariEvaluator
#define _ardbariEvaluator TR::TreeEvaluator::ardbariEvaluator
#define _brdbariEvaluator TR::TreeEvaluator::brdbariEvaluator
#define _srdbariEvaluator TR::TreeEvaluator::srdbariEvaluator
#define _lrdbariEvaluator TR::TreeEvaluator::lrdbariEvaluator
#define _istoreEvaluator TR::TreeEvaluator::istoreEvaluator
#define _lstoreEvaluator TR::TreeEvaluator::lstoreEvaluator
#define _fstoreEvaluator TR::TreeEvaluator::floatingPointStoreEvaluator
#define _dstoreEvaluator TR::TreeEvaluator::floatingPointStoreEvaluator
#define _astoreEvaluator TR::TreeEvaluator::lstoreEvaluator
#define _bstoreEvaluator TR::TreeEvaluator::bstoreEvaluator
#define _sstoreEvaluator TR::TreeEvaluator::sstoreEvaluator
#define _iwrtbarEvaluator TR::TreeEvaluator::iwrtbarEvaluator
#define _lwrtbarEvaluator TR::TreeEvaluator::lwrtbarEvaluator
#define _fwrtbarEvaluator TR::TreeEvaluator::fwrtbarEvaluator
#define _dwrtbarEvaluator TR::TreeEvaluator::dwrtbarEvaluator
#define _awrtbarEvaluator TR::TreeEvaluator::awrtbarEvaluator
#define _bwrtbarEvaluator TR::TreeEvaluator::bwrtbarEvaluator
#define _swrtbarEvaluator TR::TreeEvaluator::swrtbarEvaluator
#define _lstoreiEvaluator TR::TreeEvaluator::lstoreEvaluator
#define _fstoreiEvaluator TR::TreeEvaluator::floatingPointStoreEvaluator
#define _dstoreiEvaluator TR::TreeEvaluator::floatingPointStoreEvaluator
#define _astoreiEvaluator TR::TreeEvaluator::lstoreEvaluator
#define _bstoreiEvaluator TR::TreeEvaluator::bstoreEvaluator
#define _sstoreiEvaluator TR::TreeEvaluator::sstoreEvaluator
#define _istoreiEvaluator TR::TreeEvaluator::istoreEvaluator
#define _lwrtbariEvaluator TR::TreeEvaluator::lwrtbariEvaluator
#define _fwrtbariEvaluator TR::TreeEvaluator::fwrtbariEvaluator
#define _dwrtbariEvaluator TR::TreeEvaluator::dwrtbariEvaluator
#define _awrtbariEvaluator TR::TreeEvaluator::awrtbariEvaluator
#define _bwrtbariEvaluator TR::TreeEvaluator::bwrtbariEvaluator
#define _swrtbariEvaluator TR::TreeEvaluator::swrtbariEvaluator
#define _iwrtbariEvaluator TR::TreeEvaluator::iwrtbariEvaluator
#define _GotoEvaluator TR::TreeEvaluator::gotoEvaluator
#define _ireturnEvaluator TR::TreeEvaluator::integerReturnEvaluator
#define _lreturnEvaluator TR::TreeEvaluator::integerReturnEvaluator
#define _freturnEvaluator TR::TreeEvaluator::fpReturnEvaluator
#define _dreturnEvaluator TR::TreeEvaluator::fpReturnEvaluator
#define _areturnEvaluator TR::TreeEvaluator::integerReturnEvaluator
#define _ReturnEvaluator TR::TreeEvaluator::returnEvaluator
#define _asynccheckEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _athrowEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _icallEvaluator TR::TreeEvaluator::directCallEvaluator
#define _lcallEvaluator TR::TreeEvaluator::directCallEvaluator
#define _fcallEvaluator TR::TreeEvaluator::directCallEvaluator
#define _dcallEvaluator TR::TreeEvaluator::directCallEvaluator
#define _acallEvaluator TR::TreeEvaluator::directCallEvaluator
#define _callEvaluator TR::TreeEvaluator::directCallEvaluator
#define _iaddEvaluator TR::TreeEvaluator::integerAddEvaluator
#define _laddEvaluator TR::TreeEvaluator::integerAddEvaluator
#define _faddEvaluator TR::TreeEvaluator::faddEvaluator
#define _daddEvaluator TR::TreeEvaluator::daddEvaluator
#define _baddEvaluator TR::TreeEvaluator::baddEvaluator
#define _saddEvaluator TR::TreeEvaluator::saddEvaluator
#define _isubEvaluator TR::TreeEvaluator::integerSubEvaluator
#define _lsubEvaluator TR::TreeEvaluator::integerSubEvaluator
#define _fsubEvaluator TR::TreeEvaluator::fsubEvaluator
#define _dsubEvaluator TR::TreeEvaluator::dsubEvaluator
#define _bsubEvaluator TR::TreeEvaluator::bsubEvaluator
#define _ssubEvaluator TR::TreeEvaluator::ssubEvaluator
#define _asubEvaluator TR::TreeEvaluator::integerSubEvaluator
#define _imulEvaluator TR::TreeEvaluator::integerMulEvaluator
#define _lmulEvaluator TR::TreeEvaluator::integerMulEvaluator
#define _fmulEvaluator TR::TreeEvaluator::fmulEvaluator
#define _dmulEvaluator TR::TreeEvaluator::dmulEvaluator
#define _bmulEvaluator TR::TreeEvaluator::integerMulEvaluator
#define _smulEvaluator TR::TreeEvaluator::integerMulEvaluator
#define _idivEvaluator TR::TreeEvaluator::integerDivOrRemEvaluator
#define _ldivEvaluator TR::TreeEvaluator::integerDivOrRemEvaluator
#define _fdivEvaluator TR::TreeEvaluator::fdivEvaluator
#define _ddivEvaluator TR::TreeEvaluator::ddivEvaluator
#define _bdivEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _sdivEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _iudivEvaluator TR::TreeEvaluator::integerDivOrRemEvaluator
#define _ludivEvaluator TR::TreeEvaluator::integerDivOrRemEvaluator
#define _iremEvaluator TR::TreeEvaluator::integerDivOrRemEvaluator
#define _lremEvaluator TR::TreeEvaluator::integerDivOrRemEvaluator
#define _fremEvaluator TR::TreeEvaluator::fpRemEvaluator
#define _dremEvaluator TR::TreeEvaluator::fpRemEvaluator
#define _bremEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _sremEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _iuremEvaluator TR::TreeEvaluator::integerDivOrRemEvaluator
#define _inegEvaluator TR::TreeEvaluator::integerNegEvaluator
#define _lnegEvaluator TR::TreeEvaluator::integerNegEvaluator
#define _fnegEvaluator TR::TreeEvaluator::fpUnaryMaskEvaluator
#define _dnegEvaluator TR::TreeEvaluator::fpUnaryMaskEvaluator
#define _bnegEvaluator TR::TreeEvaluator::bnegEvaluator
#define _snegEvaluator TR::TreeEvaluator::snegEvaluator
#define _iabsEvaluator TR::TreeEvaluator::integerAbsEvaluator
#define _labsEvaluator TR::TreeEvaluator::integerAbsEvaluator
#define _fabsEvaluator TR::TreeEvaluator::fpUnaryMaskEvaluator
#define _dabsEvaluator TR::TreeEvaluator::fpUnaryMaskEvaluator
#define _ishlEvaluator TR::TreeEvaluator::integerShlEvaluator
#define _lshlEvaluator TR::TreeEvaluator::integerShlEvaluator
#define _bshlEvaluator TR::TreeEvaluator::bshlEvaluator
#define _sshlEvaluator TR::TreeEvaluator::sshlEvaluator
#define _ishrEvaluator TR::TreeEvaluator::integerShrEvaluator
#define _lshrEvaluator TR::TreeEvaluator::integerShrEvaluator
#define _bshrEvaluator TR::TreeEvaluator::bshrEvaluator
#define _sshrEvaluator TR::TreeEvaluator::sshrEvaluator
#define _iushrEvaluator TR::TreeEvaluator::integerUshrEvaluator
#define _lushrEvaluator TR::TreeEvaluator::integerUshrEvaluator
#define _bushrEvaluator TR::TreeEvaluator::bushrEvaluator
#define _sushrEvaluator TR::TreeEvaluator::sushrEvaluator
#define _irolEvaluator TR::TreeEvaluator::integerRolEvaluator
#define _lrolEvaluator TR::TreeEvaluator::integerRolEvaluator
#define _iandEvaluator TR::TreeEvaluator::iandEvaluator
#define _landEvaluator TR::TreeEvaluator::landEvaluator
#define _bandEvaluator TR::TreeEvaluator::bandEvaluator
#define _sandEvaluator TR::TreeEvaluator::sandEvaluator
#define _iorEvaluator TR::TreeEvaluator::iorEvaluator
#define _lorEvaluator TR::TreeEvaluator::lorEvaluator
#define _borEvaluator TR::TreeEvaluator::borEvaluator
#define _sorEvaluator TR::TreeEvaluator::sorEvaluator
#define _ixorEvaluator TR::TreeEvaluator::ixorEvaluator
#define _lxorEvaluator TR::TreeEvaluator::lxorEvaluator
#define _bxorEvaluator TR::TreeEvaluator::bxorEvaluator
#define _sxorEvaluator TR::TreeEvaluator::sxorEvaluator
#define _i2lEvaluator TR::TreeEvaluator::i2lEvaluator
#define _i2fEvaluator TR::TreeEvaluator::i2fEvaluator
#define _i2dEvaluator TR::TreeEvaluator::i2dEvaluator
#define _i2bEvaluator TR::TreeEvaluator::i2bEvaluator
#define _i2sEvaluator TR::TreeEvaluator::i2bEvaluator
#define _i2aEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _iu2lEvaluator TR::TreeEvaluator::iu2lEvaluator
#define _iu2fEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _iu2dEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _iu2aEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _l2iEvaluator TR::TreeEvaluator::l2iEvaluator
#define _l2fEvaluator TR::TreeEvaluator::l2fEvaluator
#define _l2dEvaluator TR::TreeEvaluator::l2dEvaluator
#define _l2bEvaluator TR::TreeEvaluator::l2iEvaluator
#define _l2sEvaluator TR::TreeEvaluator::l2iEvaluator
#define _l2aEvaluator TR::TreeEvaluator::l2aEvaluator
#define _lu2fEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _lu2dEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _lu2aEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _f2iEvaluator TR::TreeEvaluator::f2iEvaluator
#define _f2lEvaluator TR::TreeEvaluator::f2iEvaluator
#define _f2dEvaluator TR::TreeEvaluator::f2dEvaluator
#define _f2bEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _f2sEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _d2iEvaluator TR::TreeEvaluator::f2iEvaluator
#define _d2lEvaluator TR::TreeEvaluator::f2iEvaluator
#define _d2fEvaluator TR::TreeEvaluator::d2fEvaluator
#define _d2bEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _d2sEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _b2iEvaluator TR::TreeEvaluator::b2iEvaluator
#define _b2lEvaluator TR::TreeEvaluator::b2lEvaluator
#define _b2fEvaluator TR::TreeEvaluator::i2fEvaluator
#define _b2dEvaluator TR::TreeEvaluator::i2dEvaluator
#define _b2sEvaluator TR::TreeEvaluator::b2sEvaluator
#define _b2aEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _bu2iEvaluator TR::TreeEvaluator::bu2iEvaluator
#define _bu2lEvaluator TR::TreeEvaluator::bu2lEvaluator
#define _bu2fEvaluator TR::TreeEvaluator::i2fEvaluator
#define _bu2dEvaluator TR::TreeEvaluator::i2dEvaluator
#define _bu2sEvaluator TR::TreeEvaluator::bu2sEvaluator
#define _bu2aEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _s2iEvaluator TR::TreeEvaluator::s2iEvaluator
#define _s2lEvaluator TR::TreeEvaluator::s2lEvaluator
#define _s2fEvaluator TR::TreeEvaluator::i2fEvaluator
#define _s2dEvaluator TR::TreeEvaluator::i2dEvaluator
#define _s2bEvaluator TR::TreeEvaluator::i2bEvaluator
#define _s2aEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _su2iEvaluator TR::TreeEvaluator::su2iEvaluator
#define _su2lEvaluator TR::TreeEvaluator::su2lEvaluator
#define _su2fEvaluator TR::TreeEvaluator::i2fEvaluator
#define _su2dEvaluator TR::TreeEvaluator::i2dEvaluator
#define _su2aEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _a2iEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _a2lEvaluator TR::TreeEvaluator::a2lEvaluator
#define _a2bEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _a2sEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _icmpeqEvaluator TR::TreeEvaluator::integerCmpeqEvaluator
#define _icmpneEvaluator TR::TreeEvaluator::integerCmpneEvaluator
#define _icmpltEvaluator TR::TreeEvaluator::integerCmpltEvaluator
#define _icmpgeEvaluator TR::TreeEvaluator::integerCmpgeEvaluator
#define _icmpgtEvaluator TR::TreeEvaluator::integerCmpgtEvaluator
#define _icmpleEvaluator TR::TreeEvaluator::integerCmpleEvaluator
#define _iucmpltEvaluator TR::TreeEvaluator::unsignedIntegerCmpltEvaluator
#define _iucmpgeEvaluator TR::TreeEvaluator::unsignedIntegerCmpgeEvaluator
#define _iucmpgtEvaluator TR::TreeEvaluator::unsignedIntegerCmpgtEvaluator
#define _iucmpleEvaluator TR::TreeEvaluator::unsignedIntegerCmpleEvaluator
#define _lcmpeqEvaluator TR::TreeEvaluator::integerCmpeqEvaluator
#define _lcmpneEvaluator TR::TreeEvaluator::integerCmpneEvaluator
#define _lcmpltEvaluator TR::TreeEvaluator::integerCmpltEvaluator
#define _lcmpgeEvaluator TR::TreeEvaluator::integerCmpgeEvaluator
#define _lcmpgtEvaluator TR::TreeEvaluator::integerCmpgtEvaluator
#define _lcmpleEvaluator TR::TreeEvaluator::integerCmpleEvaluator
#define _lucmpltEvaluator TR::TreeEvaluator::unsignedIntegerCmpltEvaluator
#define _lucmpgeEvaluator TR::TreeEvaluator::unsignedIntegerCmpgeEvaluator
#define _lucmpgtEvaluator TR::TreeEvaluator::unsignedIntegerCmpgtEvaluator
#define _lucmpleEvaluator TR::TreeEvaluator::unsignedIntegerCmpleEvaluator
#define _fcmpeqEvaluator TR::TreeEvaluator::compareFloatAndSetEvaluator
#define _fcmpneEvaluator TR::TreeEvaluator::compareFloatAndSetEvaluator
#define _fcmpltEvaluator TR::TreeEvaluator::compareFloatAndSetEvaluator
#define _fcmpgeEvaluator TR::TreeEvaluator::compareFloatAndSetEvaluator
#define _fcmpgtEvaluator TR::TreeEvaluator::compareFloatAndSetEvaluator
#define _fcmpleEvaluator TR::TreeEvaluator::compareFloatAndSetEvaluator
#define _fcmpequEvaluator TR::TreeEvaluator::compareFloatAndSetEvaluator
#define _fcmpneuEvaluator TR::TreeEvaluator::compareFloatAndSetEvaluator
#define _fcmpltuEvaluator TR::TreeEvaluator::compareFloatAndSetEvaluator
#define _fcmpgeuEvaluator TR::TreeEvaluator::compareFloatAndSetEvaluator
#define _fcmpgtuEvaluator TR::TreeEvaluator::compareFloatAndSetEvaluator
#define _fcmpleuEvaluator TR::TreeEvaluator::compareFloatAndSetEvaluator
#define _dcmpeqEvaluator TR::TreeEvaluator::compareDoubleAndSetEvaluator
#define _dcmpneEvaluator TR::TreeEvaluator::compareDoubleAndSetEvaluator
#define _dcmpltEvaluator TR::TreeEvaluator::compareDoubleAndSetEvaluator
#define _dcmpgeEvaluator TR::TreeEvaluator::compareDoubleAndSetEvaluator
#define _dcmpgtEvaluator TR::TreeEvaluator::compareDoubleAndSetEvaluator
#define _dcmpleEvaluator TR::TreeEvaluator::compareDoubleAndSetEvaluator
#define _dcmpequEvaluator TR::TreeEvaluator::compareDoubleAndSetEvaluator
#define _dcmpneuEvaluator TR::TreeEvaluator::compareDoubleAndSetEvaluator
#define _dcmpltuEvaluator TR::TreeEvaluator::compareDoubleAndSetEvaluator
#define _dcmpgeuEvaluator TR::TreeEvaluator::compareDoubleAndSetEvaluator
#define _dcmpgtuEvaluator TR::TreeEvaluator::compareDoubleAndSetEvaluator
#define _dcmpleuEvaluator TR::TreeEvaluator::compareDoubleAndSetEvaluator
#define _acmpeqEvaluator TR::TreeEvaluator::integerCmpeqEvaluator
#define _acmpneEvaluator TR::TreeEvaluator::integerCmpneEvaluator
#define _acmpltEvaluator TR::TreeEvaluator::unsignedIntegerCmpltEvaluator
#define _acmpgeEvaluator TR::TreeEvaluator::unsignedIntegerCmpgeEvaluator
#define _acmpgtEvaluator TR::TreeEvaluator::unsignedIntegerCmpgtEvaluator
#define _acmpleEvaluator TR::TreeEvaluator::unsignedIntegerCmpleEvaluator
#define _bcmpeqEvaluator TR::TreeEvaluator::bcmpeqEvaluator
#define _bcmpneEvaluator TR::TreeEvaluator::bcmpeqEvaluator
#define _bcmpltEvaluator TR::TreeEvaluator::bcmpltEvaluator
#define _bcmpgeEvaluator TR::TreeEvaluator::bcmpgeEvaluator
#define _bcmpgtEvaluator TR::TreeEvaluator::bcmpgtEvaluator
#define _bcmpleEvaluator TR::TreeEvaluator::bcmpleEvaluator
#define _bucmpltEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _bucmpgeEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _bucmpgtEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _bucmpleEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _scmpeqEvaluator TR::TreeEvaluator::scmpeqEvaluator
#define _scmpneEvaluator TR::TreeEvaluator::scmpeqEvaluator
#define _scmpltEvaluator TR::TreeEvaluator::scmpltEvaluator
#define _scmpgeEvaluator TR::TreeEvaluator::scmpgeEvaluator
#define _scmpgtEvaluator TR::TreeEvaluator::scmpgtEvaluator
#define _scmpleEvaluator TR::TreeEvaluator::scmpleEvaluator
#define _sucmpltEvaluator TR::TreeEvaluator::sucmpltEvaluator
#define _sucmpgeEvaluator TR::TreeEvaluator::sucmpgeEvaluator
#define _sucmpgtEvaluator TR::TreeEvaluator::sucmpgtEvaluator
#define _sucmpleEvaluator TR::TreeEvaluator::sucmpleEvaluator
#define _lcmpEvaluator TR::TreeEvaluator::lcmpEvaluator
#define _fcmplEvaluator TR::TreeEvaluator::compareFloatEvaluator
#define _fcmpgEvaluator TR::TreeEvaluator::compareFloatEvaluator
#define _dcmplEvaluator TR::TreeEvaluator::compareDoubleEvaluator
#define _dcmpgEvaluator TR::TreeEvaluator::compareDoubleEvaluator
#define _ificmpeqEvaluator TR::TreeEvaluator::integerIfCmpeqEvaluator
#define _ificmpneEvaluator TR::TreeEvaluator::integerIfCmpneEvaluator
#define _ificmpltEvaluator TR::TreeEvaluator::integerIfCmpltEvaluator
#define _ificmpgeEvaluator TR::TreeEvaluator::integerIfCmpgeEvaluator
#define _ificmpgtEvaluator TR::TreeEvaluator::integerIfCmpgtEvaluator
#define _ificmpleEvaluator TR::TreeEvaluator::integerIfCmpleEvaluator
#define _ifiucmpltEvaluator TR::TreeEvaluator::unsignedIntegerIfCmpltEvaluator
#define _ifiucmpgeEvaluator TR::TreeEvaluator::unsignedIntegerIfCmpgeEvaluator
#define _ifiucmpgtEvaluator TR::TreeEvaluator::unsignedIntegerIfCmpgtEvaluator
#define _ifiucmpleEvaluator TR::TreeEvaluator::unsignedIntegerIfCmpleEvaluator
#define _iflcmpeqEvaluator TR::TreeEvaluator::integerIfCmpeqEvaluator
#define _iflcmpneEvaluator TR::TreeEvaluator::integerIfCmpneEvaluator
#define _iflcmpltEvaluator TR::TreeEvaluator::integerIfCmpltEvaluator
#define _iflcmpgeEvaluator TR::TreeEvaluator::integerIfCmpgeEvaluator
#define _iflcmpgtEvaluator TR::TreeEvaluator::integerIfCmpgtEvaluator
#define _iflcmpleEvaluator TR::TreeEvaluator::integerIfCmpleEvaluator
#define _iflucmpltEvaluator TR::TreeEvaluator::unsignedIntegerIfCmpltEvaluator
#define _iflucmpgeEvaluator TR::TreeEvaluator::unsignedIntegerIfCmpgeEvaluator
#define _iflucmpgtEvaluator TR::TreeEvaluator::unsignedIntegerIfCmpgtEvaluator
#define _iflucmpleEvaluator TR::TreeEvaluator::unsignedIntegerIfCmpleEvaluator
#define _iffcmpeqEvaluator TR::TreeEvaluator::compareFloatAndBranchEvaluator
#define _iffcmpneEvaluator TR::TreeEvaluator::compareFloatAndBranchEvaluator
#define _iffcmpltEvaluator TR::TreeEvaluator::compareFloatAndBranchEvaluator
#define _iffcmpgeEvaluator TR::TreeEvaluator::compareFloatAndBranchEvaluator
#define _iffcmpgtEvaluator TR::TreeEvaluator::compareFloatAndBranchEvaluator
#define _iffcmpleEvaluator TR::TreeEvaluator::compareFloatAndBranchEvaluator
#define _iffcmpequEvaluator TR::TreeEvaluator::compareFloatAndBranchEvaluator
#define _iffcmpneuEvaluator TR::TreeEvaluator::compareFloatAndBranchEvaluator
#define _iffcmpltuEvaluator TR::TreeEvaluator::compareFloatAndBranchEvaluator
#define _iffcmpgeuEvaluator TR::TreeEvaluator::compareFloatAndBranchEvaluator
#define _iffcmpgtuEvaluator TR::TreeEvaluator::compareFloatAndBranchEvaluator
#define _iffcmpleuEvaluator TR::TreeEvaluator::compareFloatAndBranchEvaluator
#define _ifdcmpeqEvaluator TR::TreeEvaluator::compareDoubleAndBranchEvaluator
#define _ifdcmpneEvaluator TR::TreeEvaluator::compareDoubleAndBranchEvaluator
#define _ifdcmpltEvaluator TR::TreeEvaluator::compareDoubleAndBranchEvaluator
#define _ifdcmpgeEvaluator TR::TreeEvaluator::compareDoubleAndBranchEvaluator
#define _ifdcmpgtEvaluator TR::TreeEvaluator::compareDoubleAndBranchEvaluator
#define _ifdcmpleEvaluator TR::TreeEvaluator::compareDoubleAndBranchEvaluator
#define _ifdcmpequEvaluator TR::TreeEvaluator::compareDoubleAndBranchEvaluator
#define _ifdcmpneuEvaluator TR::TreeEvaluator::compareDoubleAndBranchEvaluator
#define _ifdcmpltuEvaluator TR::TreeEvaluator::compareDoubleAndBranchEvaluator
#define _ifdcmpgeuEvaluator TR::TreeEvaluator::compareDoubleAndBranchEvaluator
#define _ifdcmpgtuEvaluator TR::TreeEvaluator::compareDoubleAndBranchEvaluator
#define _ifdcmpleuEvaluator TR::TreeEvaluator::compareDoubleAndBranchEvaluator
#define _ifacmpeqEvaluator TR::TreeEvaluator::integerIfCmpeqEvaluator
#define _ifacmpneEvaluator TR::TreeEvaluator::integerIfCmpneEvaluator
#define _ifacmpltEvaluator TR::TreeEvaluator::unsignedIntegerIfCmpltEvaluator
#define _ifacmpgeEvaluator TR::TreeEvaluator::unsignedIntegerIfCmpgeEvaluator
#define _ifacmpgtEvaluator TR::TreeEvaluator::unsignedIntegerIfCmpgtEvaluator
#define _ifacmpleEvaluator TR::TreeEvaluator::unsignedIntegerIfCmpleEvaluator
#define _ifbcmpeqEvaluator TR::TreeEvaluator::ifbcmpeqEvaluator
#define _ifbcmpneEvaluator TR::TreeEvaluator::ifbcmpeqEvaluator
#define _ifbcmpltEvaluator TR::TreeEvaluator::ifbcmpltEvaluator
#define _ifbcmpgeEvaluator TR::TreeEvaluator::ifbcmpgeEvaluator
#define _ifbcmpgtEvaluator TR::TreeEvaluator::ifbcmpgtEvaluator
#define _ifbcmpleEvaluator TR::TreeEvaluator::ifbcmpleEvaluator
#define _ifbucmpltEvaluator TR::TreeEvaluator::ifbucmpltEvaluator
#define _ifbucmpgeEvaluator TR::TreeEvaluator::ifbucmpgeEvaluator
#define _ifbucmpgtEvaluator TR::TreeEvaluator::ifbucmpgtEvaluator
#define _ifbucmpleEvaluator TR::TreeEvaluator::ifbucmpleEvaluator
#define _ifscmpeqEvaluator TR::TreeEvaluator::ifscmpeqEvaluator
#define _ifscmpneEvaluator TR::TreeEvaluator::ifscmpeqEvaluator
#define _ifscmpltEvaluator TR::TreeEvaluator::ifscmpltEvaluator
#define _ifscmpgeEvaluator TR::TreeEvaluator::ifscmpgeEvaluator
#define _ifscmpgtEvaluator TR::TreeEvaluator::ifscmpgtEvaluator
#define _ifscmpleEvaluator TR::TreeEvaluator::ifscmpleEvaluator
#define _ifsucmpltEvaluator TR::TreeEvaluator::ifsucmpltEvaluator
#define _ifsucmpgeEvaluator TR::TreeEvaluator::ifsucmpgeEvaluator
#define _ifsucmpgtEvaluator TR::TreeEvaluator::ifsucmpgtEvaluator
#define _ifsucmpleEvaluator TR::TreeEvaluator::ifsucmpleEvaluator
#define _loadaddrEvaluator TR::TreeEvaluator::loadaddrEvaluator
#define _ZEROCHKEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _callIfEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _iRegLoadEvaluator TR::TreeEvaluator::integerRegLoadEvaluator
#define _aRegLoadEvaluator TR::TreeEvaluator::aRegLoadEvaluator
#define _lRegLoadEvaluator TR::TreeEvaluator::integerRegLoadEvaluator
#define _fRegLoadEvaluator TR::TreeEvaluator::fRegLoadEvaluator
#define _dRegLoadEvaluator TR::TreeEvaluator::dRegLoadEvaluator
#define _sRegLoadEvaluator TR::TreeEvaluator::integerRegLoadEvaluator
#define _bRegLoadEvaluator TR::TreeEvaluator::integerRegLoadEvaluator
#define _iRegStoreEvaluator TR::TreeEvaluator::iRegStoreEvaluator
#define _aRegStoreEvaluator TR::TreeEvaluator::iRegStoreEvaluator
#define _lRegStoreEvaluator TR::TreeEvaluator::lRegStoreEvaluator
#define _fRegStoreEvaluator TR::TreeEvaluator::fRegStoreEvaluator
#define _dRegStoreEvaluator TR::TreeEvaluator::dRegStoreEvaluator
#define _sRegStoreEvaluator TR::TreeEvaluator::iRegStoreEvaluator
#define _bRegStoreEvaluator TR::TreeEvaluator::iRegStoreEvaluator
#define _GlRegDepsEvaluator TR::TreeEvaluator::GlRegDepsEvaluator
#define _iselectEvaluator TR::TreeEvaluator::iselectEvaluator
#define _lselectEvaluator TR::TreeEvaluator::iselectEvaluator
#define _bselectEvaluator TR::TreeEvaluator::iselectEvaluator
#define _sselectEvaluator TR::TreeEvaluator::iselectEvaluator
#define _aselectEvaluator TR::TreeEvaluator::iselectEvaluator
#define _fselectEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _dselectEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _treetopEvaluator TR::TreeEvaluator::treetopEvaluator
#define _MethodEnterHookEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _MethodExitHookEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _PassThroughEvaluator TR::TreeEvaluator::passThroughEvaluator
#define _compressedRefsEvaluator TR::TreeEvaluator::compressedRefsEvaluator
#define _BBStartEvaluator TR::TreeEvaluator::BBStartEvaluator
#define _BBEndEvaluator TR::TreeEvaluator::BBEndEvaluator
#define _viremEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _viminEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vimaxEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vigetelemEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _visetelemEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vimergelEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vimergehEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpeqEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpgtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpgeEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpltEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpleEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpalleqEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpallneEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpallgtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpallgeEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpallltEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpallleEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpanyeqEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpanyneEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpanygtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpanygeEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpanyltEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vicmpanyleEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vnotEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vbitselectEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vpermEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vsplatsEvaluator TR::TreeEvaluator::SIMDsplatsEvaluator
#define _vdmergelEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdmergehEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdsetelemEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdgetelemEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdselEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdremEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdmaddEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdnmsubEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdmsubEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdmaxEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdminEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpeqEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpneEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpgtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpgeEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpltEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpleEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpalleqEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpallneEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpallgtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpallgeEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpallltEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpallleEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpanyeqEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpanyneEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpanygtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpanygeEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpanyltEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdcmpanyleEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdsqrtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdlogEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vincEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vdecEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vnegEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vcomEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vaddEvaluator TR::TreeEvaluator::FloatingPointAndVectorBinaryArithmeticEvaluator
#define _vsubEvaluator TR::TreeEvaluator::FloatingPointAndVectorBinaryArithmeticEvaluator
#define _vmulEvaluator TR::TreeEvaluator::FloatingPointAndVectorBinaryArithmeticEvaluator
#define _vdivEvaluator TR::TreeEvaluator::FloatingPointAndVectorBinaryArithmeticEvaluator
#define _vremEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vandEvaluator TR::TreeEvaluator::FloatingPointAndVectorBinaryArithmeticEvaluator
#define _vorEvaluator TR::TreeEvaluator::FloatingPointAndVectorBinaryArithmeticEvaluator
#define _vxorEvaluator TR::TreeEvaluator::FloatingPointAndVectorBinaryArithmeticEvaluator
#define _vshlEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vushrEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vshrEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vcmpeqEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vcmpneEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vcmpltEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vucmpltEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vcmpgtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vucmpgtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vcmpleEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vucmpleEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vcmpgeEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vucmpgeEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vloadEvaluator TR::TreeEvaluator::SIMDloadEvaluator
#define _vloadiEvaluator TR::TreeEvaluator::SIMDloadEvaluator
#define _vstoreEvaluator TR::TreeEvaluator::SIMDstoreEvaluator
#define _vstoreiEvaluator TR::TreeEvaluator::SIMDstoreEvaluator
#define _vrandEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vreturnEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vcallEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vcalliEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vselectEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _v2vEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vl2vdEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vconstEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _getvelemEvaluator TR::TreeEvaluator::SIMDgetvelemEvaluator
#define _vsetelemEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _vbRegLoadEvaluator TR::TreeEvaluator::SIMDRegLoadEvaluator
#define _vsRegLoadEvaluator TR::TreeEvaluator::SIMDRegLoadEvaluator
#define _viRegLoadEvaluator TR::TreeEvaluator::SIMDRegLoadEvaluator
#define _vlRegLoadEvaluator TR::TreeEvaluator::SIMDRegLoadEvaluator
#define _vfRegLoadEvaluator TR::TreeEvaluator::SIMDRegLoadEvaluator
#define _vdRegLoadEvaluator TR::TreeEvaluator::SIMDRegLoadEvaluator
#define _vbRegStoreEvaluator TR::TreeEvaluator::SIMDRegStoreEvaluator
#define _vsRegStoreEvaluator TR::TreeEvaluator::SIMDRegStoreEvaluator
#define _viRegStoreEvaluator TR::TreeEvaluator::SIMDRegStoreEvaluator
#define _vlRegStoreEvaluator TR::TreeEvaluator::SIMDRegStoreEvaluator
#define _vfRegStoreEvaluator TR::TreeEvaluator::SIMDRegStoreEvaluator
#define _vdRegStoreEvaluator TR::TreeEvaluator::SIMDRegStoreEvaluator
#define _iuloadEvaluator TR::TreeEvaluator::iloadEvaluator
#define _luloadEvaluator TR::TreeEvaluator::lloadEvaluator
#define _buloadEvaluator TR::TreeEvaluator::bloadEvaluator
#define _iuloadiEvaluator TR::TreeEvaluator::iloadEvaluator
#define _luloadiEvaluator TR::TreeEvaluator::lloadEvaluator
#define _buloadiEvaluator TR::TreeEvaluator::bloadEvaluator
#define _iustoreEvaluator TR::TreeEvaluator::istoreEvaluator
#define _lustoreEvaluator TR::TreeEvaluator::lstoreEvaluator
#define _bustoreEvaluator TR::TreeEvaluator::bstoreEvaluator
#define _iustoreiEvaluator TR::TreeEvaluator::istoreEvaluator
#define _lustoreiEvaluator TR::TreeEvaluator::lstoreEvaluator
#define _bustoreiEvaluator TR::TreeEvaluator::bstoreEvaluator
#define _iuaddEvaluator TR::TreeEvaluator::integerAddEvaluator
#define _luaddEvaluator TR::TreeEvaluator::integerAddEvaluator
#define _buaddEvaluator TR::TreeEvaluator::baddEvaluator
#define _iusubEvaluator TR::TreeEvaluator::integerSubEvaluator
#define _lusubEvaluator TR::TreeEvaluator::integerSubEvaluator
#define _busubEvaluator TR::TreeEvaluator::bsubEvaluator
#define _iunegEvaluator TR::TreeEvaluator::integerNegEvaluator
#define _lunegEvaluator TR::TreeEvaluator::integerNegEvaluator
#define _f2iuEvaluator TR::TreeEvaluator::f2iEvaluator
#define _f2luEvaluator TR::TreeEvaluator::f2iEvaluator
#define _f2buEvaluator TR::TreeEvaluator::f2bEvaluator
#define _f2cEvaluator TR::TreeEvaluator::f2cEvaluator
#define _d2iuEvaluator TR::TreeEvaluator::f2iEvaluator
#define _d2luEvaluator TR::TreeEvaluator::f2iEvaluator
#define _d2buEvaluator TR::TreeEvaluator::d2bEvaluator
#define _d2cEvaluator TR::TreeEvaluator::d2cEvaluator
#define _iuRegLoadEvaluator TR::TreeEvaluator::integerRegLoadEvaluator
#define _luRegLoadEvaluator TR::TreeEvaluator::integerRegLoadEvaluator
#define _iuRegStoreEvaluator TR::TreeEvaluator::iRegStoreEvaluator
#define _luRegStoreEvaluator TR::TreeEvaluator::lRegStoreEvaluator
#define _cloadEvaluator TR::TreeEvaluator::sloadEvaluator
#define _cloadiEvaluator TR::TreeEvaluator::sloadEvaluator
#define _cstoreEvaluator TR::TreeEvaluator::cstoreEvaluator
#define _cstoreiEvaluator TR::TreeEvaluator::cstoreEvaluator
#define _monentEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _monexitEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _monexitfenceEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _tstartEvaluator TR::TreeEvaluator::tstartEvaluator
#define _tfinishEvaluator TR::TreeEvaluator::tfinishEvaluator
#define _tabortEvaluator TR::TreeEvaluator::tabortEvaluator
#define _instanceofEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _checkcastEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _checkcastAndNULLCHKEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _NewEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _newvalueEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _newarrayEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _anewarrayEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _variableNewEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _variableNewArrayEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _multianewarrayEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _arraylengthEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _contigarraylengthEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _discontigarraylengthEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _icalliEvaluator TR::TreeEvaluator::indirectCallEvaluator
#define _lcalliEvaluator TR::TreeEvaluator::indirectCallEvaluator
#define _fcalliEvaluator TR::TreeEvaluator::indirectCallEvaluator
#define _dcalliEvaluator TR::TreeEvaluator::indirectCallEvaluator
#define _acalliEvaluator TR::TreeEvaluator::indirectCallEvaluator
#define _calliEvaluator TR::TreeEvaluator::indirectCallEvaluator
#define _fenceEvaluator TR::TreeEvaluator::fenceEvaluator
#define _luaddhEvaluator TR::TreeEvaluator::integerAddEvaluator
#define _caddEvaluator TR::TreeEvaluator::caddEvaluator
#define _aiaddEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _aiuaddEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _aladdEvaluator TR::TreeEvaluator::integerAddEvaluator
#define _aluaddEvaluator TR::TreeEvaluator::integerAddEvaluator
#define _lusubhEvaluator TR::TreeEvaluator::integerSubEvaluator
#define _csubEvaluator TR::TreeEvaluator::csubEvaluator
#define _imulhEvaluator TR::TreeEvaluator::integerMulhEvaluator
#define _iumulhEvaluator TR::TreeEvaluator::integerMulhEvaluator
#define _lmulhEvaluator TR::TreeEvaluator::integerMulhEvaluator
#define _lumulhEvaluator TR::TreeEvaluator::integerMulhEvaluator
#define _ibits2fEvaluator TR::TreeEvaluator::ibits2fEvaluator
#define _fbits2iEvaluator TR::TreeEvaluator::fbits2iEvaluator
#define _lbits2dEvaluator TR::TreeEvaluator::lbits2dEvaluator
#define _dbits2lEvaluator TR::TreeEvaluator::dbits2lEvaluator
#define _lookupEvaluator TR::TreeEvaluator::lookupEvaluator
#define _trtLookupEvaluator TR::TreeEvaluator::NOPEvaluator
#define _CaseEvaluator TR::TreeEvaluator::NOPEvaluator
#define _tableEvaluator TR::TreeEvaluator::tableEvaluator
#define _exceptionRangeFenceEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _dbgFenceEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _NULLCHKEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _ResolveCHKEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _ResolveAndNULLCHKEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _DIVCHKEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _OverflowCHKEvaluator TR::TreeEvaluator::overflowCHKEvaluator
#define _UnsignedOverflowCHKEvaluator TR::TreeEvaluator::overflowCHKEvaluator
#define _BNDCHKEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _ArrayCopyBNDCHKEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _BNDCHKwithSpineCHKEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _SpineCHKEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _ArrayStoreCHKEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _ArrayCHKEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _RetEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _arraycopyEvaluator TR::TreeEvaluator::arraycopyEvaluator
#define _arraysetEvaluator TR::TreeEvaluator::arraysetEvaluator
#define _arraytranslateEvaluator TR::TreeEvaluator::arraytranslateEvaluator
#define _arraytranslateAndTestEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _long2StringEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _bitOpMemEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _bitOpMemNDEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _arraycmpEvaluator TR::TreeEvaluator::arraycmpEvaluator
#define _arraycmpWithPadEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _allocationFenceEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _loadFenceEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _storeFenceEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _fullFenceEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _MergeNewEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _computeCCEvaluator TR::TreeEvaluator::computeCCEvaluator
#define _butestEvaluator TR::TreeEvaluator::butestEvaluator
#define _sutestEvaluator TR::TreeEvaluator::sutestEvaluator
#define _bucmpEvaluator TR::TreeEvaluator::bucmpEvaluator
#define _bcmpEvaluator TR::TreeEvaluator::bcmpEvaluator
#define _sucmpEvaluator TR::TreeEvaluator::sucmpEvaluator
#define _scmpEvaluator TR::TreeEvaluator::scmpEvaluator
#define _iucmpEvaluator TR::TreeEvaluator::iucmpEvaluator
#define _icmpEvaluator TR::TreeEvaluator::icmpEvaluator
#define _lucmpEvaluator TR::TreeEvaluator::iucmpEvaluator
#define _ificmpoEvaluator TR::TreeEvaluator::ifxcmpoEvaluator
#define _ificmpnoEvaluator TR::TreeEvaluator::ifxcmpoEvaluator
#define _iflcmpoEvaluator TR::TreeEvaluator::ifxcmpoEvaluator
#define _iflcmpnoEvaluator TR::TreeEvaluator::ifxcmpoEvaluator
#define _ificmnoEvaluator TR::TreeEvaluator::ifxcmpoEvaluator
#define _ificmnnoEvaluator TR::TreeEvaluator::ifxcmpoEvaluator
#define _iflcmnoEvaluator TR::TreeEvaluator::ifxcmpoEvaluator
#define _iflcmnnoEvaluator TR::TreeEvaluator::ifxcmpoEvaluator
#define _iuaddcEvaluator TR::TreeEvaluator::integerAddEvaluator
#define _luaddcEvaluator TR::TreeEvaluator::integerAddEvaluator
#define _iusubbEvaluator TR::TreeEvaluator::integerSubEvaluator
#define _lusubbEvaluator TR::TreeEvaluator::integerSubEvaluator
#define _icmpsetEvaluator TR::TreeEvaluator::icmpsetEvaluator
#define _lcmpsetEvaluator TR::TreeEvaluator::icmpsetEvaluator
#define _bztestnsetEvaluator TR::TreeEvaluator::bztestnsetEvaluator
#define _ibatomicorEvaluator TR::TreeEvaluator::atomicorEvaluator
#define _isatomicorEvaluator TR::TreeEvaluator::atomicorEvaluator
#define _iiatomicorEvaluator TR::TreeEvaluator::atomicorEvaluator
#define _ilatomicorEvaluator TR::TreeEvaluator::atomicorEvaluator
#define _dexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _branchEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _igotoEvaluator TR::TreeEvaluator::igotoEvaluator
#define _bexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _buexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _sexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _cexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _iexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _iuexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _lexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _luexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _fexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _fuexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _duexpEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ixfrsEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _lxfrsEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _fxfrsEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dxfrsEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _fintEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dintEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _fnintEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dnintEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _fsqrtEvaluator TR::TreeEvaluator::fpSqrtEvaluator
#define _dsqrtEvaluator TR::TreeEvaluator::dsqrtEvaluator
#define _getstackEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _deallocaEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _idozEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dcosEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dsinEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dtanEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dcoshEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dsinhEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dtanhEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dacosEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dasinEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _datanEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _datan2Evaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dlogEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dfloorEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ffloorEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dceilEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _fceilEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ibranchEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _mbranchEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _getpmEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _setpmEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _loadAutoOffsetEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _imaxEvaluator TR::TreeEvaluator::minmaxEvaluator
#define _iumaxEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _lmaxEvaluator TR::TreeEvaluator::minmaxEvaluator
#define _lumaxEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _fmaxEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dmaxEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _iminEvaluator TR::TreeEvaluator::minmaxEvaluator
#define _iuminEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _lminEvaluator TR::TreeEvaluator::minmaxEvaluator
#define _luminEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _fminEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _dminEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _trtEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _trtSimpleEvaluator TR::TreeEvaluator::unImpOpEvaluator
#define _ihbitEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _ilbitEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _inolzEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _inotzEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _ipopcntEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _lhbitEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _llbitEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _lnolzEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _lnotzEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _lpopcntEvaluator TR::TreeEvaluator::badILOpEvaluator
#define _sbyteswapEvaluator TR::TreeEvaluator::sbyteswapEvaluator
#define _ibyteswapEvaluator TR::TreeEvaluator::ibyteswapEvaluator
#define _lbyteswapEvaluator TR::TreeEvaluator::ibyteswapEvaluator
#define _bbitpermuteEvaluator TR::TreeEvaluator::bitpermuteEvaluator
#define _sbitpermuteEvaluator TR::TreeEvaluator::bitpermuteEvaluator
#define _ibitpermuteEvaluator TR::TreeEvaluator::bitpermuteEvaluator
#define _lbitpermuteEvaluator TR::TreeEvaluator::bitpermuteEvaluator
#define _PrefetchEvaluator TR::TreeEvaluator::PrefetchEvaluator

#define OPCODE_MACRO(\
   opcode, \
   name, \
   prop1, \
   prop2, \
   prop3, \
   prop4, \
   dataType, \
   typeProps, \
   childProps, \
   swapChildrenOpcode, \
   reverseBranchOpcode, \
   boolCompareOpcode, \
   ifCompareOpcode, \
   ...) _ ## opcode ## Evaluator,

   _BadILOpEvaluator,

#include "il/Opcodes.enum"
#undef OPCODE_MACRO
